(* Automatically generated code - DO NOT MODIFY *)

open S

type unimplemented =
        string
with rpc
exception Unimplemented of string
(** The operation has not been implemented *)
let response_of_exn = function
    | Unimplemented(arg_1) -> Rpc.failure (Rpc.Enum [ Rpc.String "Unimplemented"; rpc_of_unimplemented (arg_1) ])
    | e -> Rpc.failure (Rpc.Enum [ Rpc.String "Internal_error"; Rpc.String (Printexc.to_string e) ])
let result_of_response = function
    | { Rpc.success = true; contents = t } -> Result.return t
    | { Rpc.success = false; contents = Rpc.Enum [ Rpc.String "Unimplemented"; args ] } ->
        let arg_1 = unimplemented_of_rpc args in
        Result.fail (Unimplemented (arg_1))
    | { Rpc.success = false; contents = t } -> Result.fail (S.Internal_error (Rpc.to_string t))
module Types = struct
    type debug_info =
            string
    with rpc
    (** Debug context from the caller *)
    type domain =
            string
    with rpc
    (** A string representing a Xen domain on the local host. The string is guaranteed to be unique per-domain but it is not guaranteed to take any particular form. It may (for example) be a Xen domain id, a Xen VM uuid or a Xenstore path or anything else chosen by the toolstack. Implementations should not assume the string has any meaning. *)
    type uri =
            string
    with rpc
    (** A URI representing the means for accessing the volume data. The interpretation of the URI is specific to the implementation. Xapi will choose which implementation to use based on the URI scheme. *)
    type implementation =
            | Blkback of string (** use kernel blkback with the given 'params' key *)
            | Tapdisk3 of string (** use userspace tapdisk3 with the given 'params' key *)
            | Qdisk of string (** use userspace qemu qdisk with the given 'params' key *)
    with rpc
    (** The choice of blkback to use. *)
    type backend =
            {
            domain_uuid: string; (** UUID of the domain hosting the backend *)
            implementation: implementation; (** choice of implementation technology *)
            }
    with rpc
    (** A description of which Xen block backend to use. The toolstack needs this to setup the shared memory connection to blkfront in the VM. *)
    type unimplemented =
            string
    with rpc
    exception Unimplemented of string
    (** The operation has not been implemented *)
    module Datapath = struct
        module Attach = struct
            module In = struct
                type t = {
                    dbg: 
                            debug_info
                    ;
                    uri: 
                            uri
                    ;
                    domain: 
                            domain
                    ;
                } with rpc
                let make dbg uri domain = { dbg = dbg; uri = uri; domain = domain }
            end
            module Out = struct
                type t = 
                        backend
                with rpc
            end
            module CommandLine = struct
                open Cmdliner
                let doc = "[attach uri domain] prepares a connection between the storage named by [uri] and the Xen domain with id [domain]. The return value is the information needed by the Xen toolstack to setup the shared-memory blkfront protocol. Note that the same volume may be simultaneously attached to multiple hosts for example over a migrate. If an implementation needs to perform an explicit handover, then it should implement [activate] and [deactivate]. This function is idempotent."
                let t =
                    let dbg =
                        let doc = "Debug context from the caller" in
                        Arg.(value & opt string "" & info ["dbg"] ~doc) in
                    let uri =
                        let doc = "A URI which represents how to access the volume disk data." in
                        Arg.(value & opt string "" & info ["uri"] ~doc) in
                    let domain =
                        let doc = "An opaque string which represents the Xen domain." in
                        Arg.(value & opt string "" & info ["domain"] ~doc) in
                    let ($) = Term.($) in
                    Term.pure In.make $ dbg $ uri $ domain
            end
        end
        module Activate = struct
            module In = struct
                type t = {
                    dbg: 
                            debug_info
                    ;
                    uri: 
                            uri
                    ;
                    domain: 
                            domain
                    ;
                } with rpc
                let make dbg uri domain = { dbg = dbg; uri = uri; domain = domain }
            end
            module Out = struct
            type t = unit with rpc
            end
            module CommandLine = struct
                open Cmdliner
                let doc = "[activate uri domain] is called just before a VM needs to read or write its disk. This is an opportunity for an implementation which needs to perform an explicit volume handover to do it. This function is called in the migration downtime window so delays here will be noticeable to users and should be minimised. This function is idempotent."
                let t =
                    let dbg =
                        let doc = "Debug context from the caller" in
                        Arg.(value & opt string "" & info ["dbg"] ~doc) in
                    let uri =
                        let doc = "A URI which represents how to access the volume disk data." in
                        Arg.(value & opt string "" & info ["uri"] ~doc) in
                    let domain =
                        let doc = "An opaque string which represents the Xen domain." in
                        Arg.(value & opt string "" & info ["domain"] ~doc) in
                    let ($) = Term.($) in
                    Term.pure In.make $ dbg $ uri $ domain
            end
        end
        module Deactivate = struct
            module In = struct
                type t = {
                    dbg: 
                            debug_info
                    ;
                    uri: 
                            uri
                    ;
                    domain: 
                            domain
                    ;
                } with rpc
                let make dbg uri domain = { dbg = dbg; uri = uri; domain = domain }
            end
            module Out = struct
            type t = unit with rpc
            end
            module CommandLine = struct
                open Cmdliner
                let doc = "[deactivate uri domain] is called as soon as a VM has finished reading or writing its disk. This is an opportunity for an implementation which needs to perform an explicit volume handover to do it. This function is called in the migration downtime window so delays here will be noticeable to users and should be minimised. This function is idempotent."
                let t =
                    let dbg =
                        let doc = "Debug context from the caller" in
                        Arg.(value & opt string "" & info ["dbg"] ~doc) in
                    let uri =
                        let doc = "A URI which represents how to access the volume disk data." in
                        Arg.(value & opt string "" & info ["uri"] ~doc) in
                    let domain =
                        let doc = "An opaque string which represents the Xen domain." in
                        Arg.(value & opt string "" & info ["domain"] ~doc) in
                    let ($) = Term.($) in
                    Term.pure In.make $ dbg $ uri $ domain
            end
        end
        module Detach = struct
            module In = struct
                type t = {
                    dbg: 
                            debug_info
                    ;
                    uri: 
                            uri
                    ;
                    domain: 
                            domain
                    ;
                } with rpc
                let make dbg uri domain = { dbg = dbg; uri = uri; domain = domain }
            end
            module Out = struct
            type t = unit with rpc
            end
            module CommandLine = struct
                open Cmdliner
                let doc = "[detach uri domain] is called sometime after a VM has finished reading or writing its disk. This is an opportunity to clean up any resources associated with the disk. This function is called outside the migration downtime window so can be slow without affecting users. This function is idempotent. This function should never fail. If an implementation is unable to perform some cleanup right away then it should queue the action internally. Any error result represents a bug in the implementation."
                let t =
                    let dbg =
                        let doc = "Debug context from the caller" in
                        Arg.(value & opt string "" & info ["dbg"] ~doc) in
                    let uri =
                        let doc = "A URI which represents how to access the volume disk data." in
                        Arg.(value & opt string "" & info ["uri"] ~doc) in
                    let domain =
                        let doc = "An opaque string which represents the Xen domain." in
                        Arg.(value & opt string "" & info ["domain"] ~doc) in
                    let ($) = Term.($) in
                    Term.pure In.make $ dbg $ uri $ domain
            end
        end
        module In = struct
            type t =
                | Attach of Attach.In.t
                | Activate of Activate.In.t
                | Deactivate of Deactivate.In.t
                | Detach of Detach.In.t
            with rpc
            let of_call (call: Rpc.call) : (t, 'b) Result.t =
                match call.Rpc.name, call.Rpc.params with
                    | "Datapath.attach", [ args ] ->
                        Result.return (Attach(Attach.In.t_of_rpc args))
                    | "Datapath.activate", [ args ] ->
                        Result.return (Activate(Activate.In.t_of_rpc args))
                    | "Datapath.deactivate", [ args ] ->
                        Result.return (Deactivate(Deactivate.In.t_of_rpc args))
                    | "Datapath.detach", [ args ] ->
                        Result.return (Detach(Detach.In.t_of_rpc args))
                    | name, params -> Result.fail (Unknown_method name)
            let call_of = function
                | Attach args -> Rpc.call "Datapath.attach" [ Attach.In.rpc_of_t args ]
                | Activate args -> Rpc.call "Datapath.activate" [ Activate.In.rpc_of_t args ]
                | Deactivate args -> Rpc.call "Datapath.deactivate" [ Deactivate.In.rpc_of_t args ]
                | Detach args -> Rpc.call "Datapath.detach" [ Detach.In.rpc_of_t args ]
        end
        module Out = struct
            type t =
                | Attach of Attach.Out.t
                | Activate of Activate.Out.t
                | Deactivate of Deactivate.Out.t
                | Detach of Detach.Out.t
            with rpc
            let response_of = function
                | `Error exn ->
                    Rpc.failure (Rpc.String (Printf.sprintf "Internal_error: %s" (Printexc.to_string exn)))
                | `Ok (Attach x) ->
                    Rpc.success (Attach.Out.rpc_of_t x)
                | `Ok (Activate x) ->
                    Rpc.success (Activate.Out.rpc_of_t x)
                | `Ok (Deactivate x) ->
                    Rpc.success (Deactivate.Out.rpc_of_t x)
                | `Ok (Detach x) ->
                    Rpc.success (Detach.Out.rpc_of_t x)
        end
    end
end
module type DATAPATH = sig
    include S.M
    val attach: Types.Datapath.Attach.In.t -> (Types.Datapath.Attach.Out.t, exn) Result.t t
    val activate: Types.Datapath.Activate.In.t -> (Types.Datapath.Activate.Out.t, exn) Result.t t
    val deactivate: Types.Datapath.Deactivate.In.t -> (Types.Datapath.Deactivate.Out.t, exn) Result.t t
    val detach: Types.Datapath.Detach.In.t -> (Types.Datapath.Detach.Out.t, exn) Result.t t
end
module Datapath_server_dispatcher = functor(Impl: DATAPATH) -> struct
    type 'a t = 'a Impl.t
    let (>>=) = Impl.(>>=)
    let return = Impl.return
    let dispatch (request: Types.Datapath.In.t) : (Types.Datapath.Out.t, 'b) Result.t Impl.t = match request with
        | Types.Datapath.In.Attach x ->
            Impl.attach x
            >>= fun result ->
            return (Result.(>>=) result (fun ok ->
                Result.return (Types.Datapath.Out.Attach ok)
            ))
        | Types.Datapath.In.Activate x ->
            Impl.activate x
            >>= fun result ->
            return (Result.(>>=) result (fun ok ->
                Result.return (Types.Datapath.Out.Activate ok)
            ))
        | Types.Datapath.In.Deactivate x ->
            Impl.deactivate x
            >>= fun result ->
            return (Result.(>>=) result (fun ok ->
                Result.return (Types.Datapath.Out.Deactivate ok)
            ))
        | Types.Datapath.In.Detach x ->
            Impl.detach x
            >>= fun result ->
            return (Result.(>>=) result (fun ok ->
                Result.return (Types.Datapath.Out.Detach ok)
            ))
    let rpc (call: Rpc.call) : Rpc.response Impl.t =
        match Types.Datapath.In.of_call call with
            | `Ok x ->
                dispatch x >>= fun result ->
                return (Types.Datapath.Out.response_of result)
            | `Error e ->
                return (response_of_exn e)
end
module Datapath_skeleton = functor(M: S.M) -> struct
    include M
    open Types
    let attach x =
        let open Datapath.Attach in
        return (`Error (Unimplemented "Datapath.attach"))
    let activate x =
        let open Datapath.Activate in
        return (`Error (Unimplemented "Datapath.activate"))
    let deactivate x =
        let open Datapath.Deactivate in
        return (`Error (Unimplemented "Datapath.deactivate"))
    let detach x =
        let open Datapath.Detach in
        return (`Error (Unimplemented "Datapath.detach"))
end
module Datapath_test = functor(M: S.M) -> struct
    include M
    open Types
    let attach x =
        let open Datapath.Attach in
        return (`Ok (Out.({ domain_uuid = "string"; implementation = Blkback "string" })))
    let activate x =
        let open Datapath.Activate in
        return (`Ok ())
    let deactivate x =
        let open Datapath.Deactivate in
        return (`Ok ())
    let detach x =
        let open Datapath.Detach in
        return (`Ok ())
end
module Datapath_client = functor(RPC: RPC) -> struct
    open RPC
    let attach_r x =
        let call = Types.Datapath.In.call_of (Types.Datapath.In.Attach x) in
        RPC.rpc call >>= fun response ->
        let result = Result.(>>=) (result_of_response response) (fun x -> Result.return (Types.Datapath.Attach.Out.t_of_rpc x)) in
        return result
    let attach ~dbg ~uri ~domain =
        let r = Types.Datapath.Attach.In.({ dbg = dbg; uri = uri; domain = domain }) in
        attach_r r
    let activate_r x =
        let call = Types.Datapath.In.call_of (Types.Datapath.In.Activate x) in
        RPC.rpc call >>= fun response ->
        let result = Result.(>>=) (result_of_response response) (fun x -> Result.return (Types.Datapath.Activate.Out.t_of_rpc x)) in
        return result
    let activate ~dbg ~uri ~domain =
        let r = Types.Datapath.Activate.In.({ dbg = dbg; uri = uri; domain = domain }) in
        activate_r r
    let deactivate_r x =
        let call = Types.Datapath.In.call_of (Types.Datapath.In.Deactivate x) in
        RPC.rpc call >>= fun response ->
        let result = Result.(>>=) (result_of_response response) (fun x -> Result.return (Types.Datapath.Deactivate.Out.t_of_rpc x)) in
        return result
    let deactivate ~dbg ~uri ~domain =
        let r = Types.Datapath.Deactivate.In.({ dbg = dbg; uri = uri; domain = domain }) in
        deactivate_r r
    let detach_r x =
        let call = Types.Datapath.In.call_of (Types.Datapath.In.Detach x) in
        RPC.rpc call >>= fun response ->
        let result = Result.(>>=) (result_of_response response) (fun x -> Result.return (Types.Datapath.Detach.Out.t_of_rpc x)) in
        return result
    let detach ~dbg ~uri ~domain =
        let r = Types.Datapath.Detach.In.({ dbg = dbg; uri = uri; domain = domain }) in
        detach_r r
end