(* Automatically generated code - DO NOT MODIFY *)

open S

type unimplemented =
        string
with rpc
exception Unimplemented of string
(** The operation has not been implemented *)
let response_of_exn = function
    | Unimplemented(arg_1) -> Rpc.failure (Rpc.Enum [ Rpc.String "Unimplemented"; rpc_of_unimplemented (arg_1) ])
    | e -> Rpc.failure (Rpc.Enum [ Rpc.String "Internal_error"; Rpc.String (Printexc.to_string e) ])
let result_of_response = function
    | { Rpc.success = true; contents = t } -> Result.return t
    | { Rpc.success = false; contents = Rpc.Enum [ Rpc.String "Unimplemented"; args ] } ->
        let arg_1 = unimplemented_of_rpc args in
        Result.fail (Unimplemented (arg_1))
    | { Rpc.success = false; contents = t } -> Result.fail (S.Internal_error (Rpc.to_string t))
module Types = struct
    type debug_info =
            string
    with rpc
    (** Debug context from the caller *)
    type query_result =
            {
            plugin: string; (** plugin name, used in the XenAPI as SR.type *)
            name: string; (** short name *)
            description: string; (** description *)
            vendor: string; (** entity (e.g. company, project, group) which produced this implementation *)
            copyright: string; (** copyright *)
            version: string; (** version *)
            required_api_version: string; (** minimum required API version *)
            features: ( string list ); (** features supported by this plugin *)
            configuration: (( string * string ) list); (** key/description pairs describing required device_config parameters *)
            }
    with rpc
    (** properties of this implementation *)
    type unimplemented =
            string
    with rpc
    exception Unimplemented of string
    (** The operation has not been implemented *)
    module Plugin = struct
        module Query = struct
            module In = struct
                type t = {
                    dbg: 
                            debug_info
                    ;
                } with rpc
                let make dbg = { dbg = dbg }
            end
            module Out = struct
                type t = 
                        query_result
                with rpc
            end
            module CommandLine = struct
                open Cmdliner
                let doc = "Query this implementation and return its properties. This is  called by xapi to determine whether it is compatible with xapi  and to discover the supported features."
                let t =
                    let dbg =
                        let doc = "Debug context from the caller" in
                        Arg.(value & opt string "" & info ["dbg"] ~doc) in
                    let ($) = Term.($) in
                    Term.pure In.make $ dbg
            end
        end
        module Ls = struct
            module In = struct
                type t = {
                    dbg: 
                            debug_info
                    ;
                } with rpc
                let make dbg = { dbg = dbg }
            end
            module Out = struct
                type t = 
                        (
                        string
                        list
                        )
                with rpc
            end
            module CommandLine = struct
                open Cmdliner
                let doc = "[ls dbg]: returns a list of attached SRs"
                let t =
                    let dbg =
                        let doc = "Debug context from the caller" in
                        Arg.(value & opt string "" & info ["dbg"] ~doc) in
                    let ($) = Term.($) in
                    Term.pure In.make $ dbg
            end
        end
        module Diagnostics = struct
            module In = struct
                type t = {
                    dbg: 
                            debug_info
                    ;
                } with rpc
                let make dbg = { dbg = dbg }
            end
            module Out = struct
                type t = 
                        string
                with rpc
            end
            module CommandLine = struct
                open Cmdliner
                let doc = "Returns a printable set of backend diagnostic information. Implementations are encouraged to include any data which will  be useful to diagnose problems. Note this data should not  include personally-identifiable data as it is intended to be  automatically included in bug reports."
                let t =
                    let dbg =
                        let doc = "Debug context from the caller" in
                        Arg.(value & opt string "" & info ["dbg"] ~doc) in
                    let ($) = Term.($) in
                    Term.pure In.make $ dbg
            end
        end
        module In = struct
            type t =
                | Query of Query.In.t
                | Ls of Ls.In.t
                | Diagnostics of Diagnostics.In.t
            with rpc
            let of_call (call: Rpc.call) : (t, 'b) Result.t =
                match call.Rpc.name, call.Rpc.params with
                    | "Plugin.query", [ args ] ->
                        Result.return (Query(Query.In.t_of_rpc args))
                    | "Plugin.ls", [ args ] ->
                        Result.return (Ls(Ls.In.t_of_rpc args))
                    | "Plugin.diagnostics", [ args ] ->
                        Result.return (Diagnostics(Diagnostics.In.t_of_rpc args))
                    | name, params -> Result.fail (Unknown_method name)
            let call_of = function
                | Query args -> Rpc.call "Plugin.query" [ Query.In.rpc_of_t args ]
                | Ls args -> Rpc.call "Plugin.ls" [ Ls.In.rpc_of_t args ]
                | Diagnostics args -> Rpc.call "Plugin.diagnostics" [ Diagnostics.In.rpc_of_t args ]
        end
        module Out = struct
            type t =
                | Query of Query.Out.t
                | Ls of Ls.Out.t
                | Diagnostics of Diagnostics.Out.t
            with rpc
            let response_of = function
                | `Error exn ->
                    Rpc.failure (Rpc.String (Printf.sprintf "Internal_error: %s" (Printexc.to_string exn)))
                | `Ok (Query x) ->
                    Rpc.success (Query.Out.rpc_of_t x)
                | `Ok (Ls x) ->
                    Rpc.success (Ls.Out.rpc_of_t x)
                | `Ok (Diagnostics x) ->
                    Rpc.success (Diagnostics.Out.rpc_of_t x)
        end
    end
end
module type PLUGIN = sig
    include S.M
    val query: Types.Plugin.Query.In.t -> (Types.Plugin.Query.Out.t, exn) Result.t t
    val ls: Types.Plugin.Ls.In.t -> (Types.Plugin.Ls.Out.t, exn) Result.t t
    val diagnostics: Types.Plugin.Diagnostics.In.t -> (Types.Plugin.Diagnostics.Out.t, exn) Result.t t
end
module Plugin_server_dispatcher = functor(Impl: PLUGIN) -> struct
    type 'a t = 'a Impl.t
    let (>>=) = Impl.(>>=)
    let return = Impl.return
    let dispatch (request: Types.Plugin.In.t) : (Types.Plugin.Out.t, 'b) Result.t Impl.t = match request with
        | Types.Plugin.In.Query x ->
            Impl.query x
            >>= fun result ->
            return (Result.(>>=) result (fun ok ->
                Result.return (Types.Plugin.Out.Query ok)
            ))
        | Types.Plugin.In.Ls x ->
            Impl.ls x
            >>= fun result ->
            return (Result.(>>=) result (fun ok ->
                Result.return (Types.Plugin.Out.Ls ok)
            ))
        | Types.Plugin.In.Diagnostics x ->
            Impl.diagnostics x
            >>= fun result ->
            return (Result.(>>=) result (fun ok ->
                Result.return (Types.Plugin.Out.Diagnostics ok)
            ))
    let rpc (call: Rpc.call) : Rpc.response Impl.t =
        match Types.Plugin.In.of_call call with
            | `Ok x ->
                dispatch x >>= fun result ->
                return (Types.Plugin.Out.response_of result)
            | `Error e ->
                return (response_of_exn e)
end
module Plugin_skeleton = functor(M: S.M) -> struct
    include M
    open Types
    let query x =
        let open Plugin.Query in
        return (`Error (Unimplemented "Plugin.query"))
    let ls x =
        let open Plugin.Ls in
        return (`Error (Unimplemented "Plugin.ls"))
    let diagnostics x =
        let open Plugin.Diagnostics in
        return (`Error (Unimplemented "Plugin.diagnostics"))
end
module Plugin_test = functor(M: S.M) -> struct
    include M
    open Types
    let query x =
        let open Plugin.Query in
        return (`Ok (Out.({ plugin = "string"; name = "string"; description = "string"; vendor = "string"; copyright = "string"; version = "string"; required_api_version = "string"; features = [ "string"; "string" ]; configuration = [ ("string", "string") ] })))
    let ls x =
        let open Plugin.Ls in
        return (`Ok (Out.([ "string"; "string" ])))
    let diagnostics x =
        let open Plugin.Diagnostics in
        return (`Ok (Out.("string")))
end
module Plugin_client = functor(RPC: RPC) -> struct
    open RPC
    let query_r x =
        let call = Types.Plugin.In.call_of (Types.Plugin.In.Query x) in
        RPC.rpc call >>= fun response ->
        let result = Result.(>>=) (result_of_response response) (fun x -> Result.return (Types.Plugin.Query.Out.t_of_rpc x)) in
        return result
    let query ~dbg =
        let r = Types.Plugin.Query.In.({ dbg = dbg }) in
        query_r r
    let ls_r x =
        let call = Types.Plugin.In.call_of (Types.Plugin.In.Ls x) in
        RPC.rpc call >>= fun response ->
        let result = Result.(>>=) (result_of_response response) (fun x -> Result.return (Types.Plugin.Ls.Out.t_of_rpc x)) in
        return result
    let ls ~dbg =
        let r = Types.Plugin.Ls.In.({ dbg = dbg }) in
        ls_r r
    let diagnostics_r x =
        let call = Types.Plugin.In.call_of (Types.Plugin.In.Diagnostics x) in
        RPC.rpc call >>= fun response ->
        let result = Result.(>>=) (result_of_response response) (fun x -> Result.return (Types.Plugin.Diagnostics.Out.t_of_rpc x)) in
        return result
    let diagnostics ~dbg =
        let r = Types.Plugin.Diagnostics.In.({ dbg = dbg }) in
        diagnostics_r r
end